import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.*;

import javax.swing.*;
import javax.swing.border.*;

import sun.awt.*;

import com.sun.media.sound.*;

/**
 * @author MR_J
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class Malkasten extends JPanel 
{
	private JPanel HauptPanel;
	
	private ZeichenbrettPanel Zeichenbrett;
	
	private JPanel ButtonPanel_Zeichnung_Einstellungen;
	private JPanel ButtonPanel_Rendering_Parameter;
	private JPanel ButtonPanel_Geometrische_Bearbeitung;
	
	private JPanel basisAuswahl,manipulationsPanel;
	
	private Stroke b1,b2,b3,aktuellerStroke;
	
	private int Grd_Color,textureColor;
	
	private Color aktuelleFarbe;
	
	private JPanel Strokewahl;
	private JPanel Farbwahl;
	
	private JPanel Strichbreite;
	
	private JPanel normFarbe;
	private JPanel gradFarbe;
	private JPanel textureFarbe;
	
	private boolean braucheStrichAttribute;
	private boolean braucheFuellAttribute;
	private boolean liniezeichnen;
	
	private JPanel RenderingGschichten;
	
	private JPanel allgemeines_rendering,anti_aliasing_panel,dithering_panel;
	
	private JLabel RenderingTitel;
	
	private ButtonGroup was_Will_Der_Trottel_Malen,wie_dick_mog_as_denn,welches_Schweinderl_haettens_denn_gerne;
	
	private JRadioButton Ellipse,Kreis,Rechteck,Rundes_Rechteck,Winkel,Linie,GP;
	
	private JButton Stroke,Fill;
	
	private JRadioButton rot,gruen,gelb,blau,orange,pink,grad_rot_schwarz,grad_gruen_gelb,grad_blau_rot;
	private JRadioButton strichst_1,strichst_2,strichst_3,texturepaint_1;
	
	private JLabel Allg_Ren_Titel;
	private JRadioButton rendering_Schnell,rendering_Quality;
	private ButtonGroup bg_rendering;
	
	private JLabel antialiasing_Titel;
	private JRadioButton antialiasing_On,antialiasing_Off;
	private ButtonGroup bg_antialiasing;
	
	private JLabel Dithering_Titel;
	private JRadioButton dithering_On,dithering_Off;
	private ButtonGroup bg_dithering;
	 	
	private JRadioButton editModus,malModus;
	private ButtonGroup bg_moduswahl;
	private JButton neuesBlatt;
	
	private JButton zoom_in,zoom_out,rotate_left,rotate_right;
	
	private Point2D Anfangspunkt_Linie,EndPunkt_Linie;
	private Vector GP_Vector;
	
	public Malkasten()
	{
	
	this.setLayout(new MalkastenLayout());
	this.setBackground(Color.WHITE);
	
	liniezeichnen=false;
	
	braucheFuellAttribute=false;
	braucheFuellAttribute=false;
	
	Grd_Color=0;
	textureColor=0;
	aktuelleFarbe=null;
	Anfangspunkt_Linie=null;
	EndPunkt_Linie=null;
	aktuellerStroke = null;
	
	GP_Vector = new Vector();
	
	b1 = new BasicStroke(3.0f);
	b2 = new BasicStroke(5.0f);
	b3 = new BasicStroke(10.0f);
	
	aktuellerStroke = b1;
	
	Zeichenbrett = new ZeichenbrettPanel();
	Zeichenbrett.setBackground(Color.BLACK);
	Zeichenbrett.setBorder(BorderFactory.createBevelBorder(
		BevelBorder.LOWERED,Color.WHITE,Color.WHITE));
	Zeichenbrett.setOpaque(true);	
	Zeichenbrett.addMouseListener(new MouseAdapter()
	{
		public void mouseClicked(MouseEvent me)
		{
			if(!editModus.isSelected())
			{
					
				if(rot.isSelected()) 
				{
					aktuelleFarbe = Color.RED;
					rot.setSelected(false);
				}
				
				if(gruen.isSelected()) 
				{
					aktuelleFarbe = Color.GREEN;
					gruen.setSelected(false);
				}
				
				if(gelb.isSelected()) 
				{
					aktuelleFarbe = Color.YELLOW;
					gelb.setSelected(false);
				}
				
				if(blau.isSelected()) 
				{
					aktuelleFarbe = Color.BLUE;
					blau.setSelected(false);
				}
				
				if(orange.isSelected()) 
				{
					aktuelleFarbe = Color.ORANGE;
					orange.setSelected(false);
				}
				
				if(pink.isSelected()) 
				{
					aktuelleFarbe = Color.PINK;
					pink.setSelected(false);
				}
				
				if(grad_rot_schwarz.isSelected()) 	
				{
					Grd_Color=1;
					grad_rot_schwarz.setSelected(false);
				}
				
				if(grad_gruen_gelb.isSelected())	
				{
					Grd_Color=2;
					grad_gruen_gelb.setSelected(false);
				}
				
				if(grad_blau_rot.isSelected())
				{
					Grd_Color=3;
					grad_blau_rot.setSelected(false);
				}
				
				if(texturepaint_1.isSelected())
				{
					textureColor=1;
					texturepaint_1.setSelected(false);
				}
				
				if(Ellipse.isSelected())
				{
					Ellipse2D.Double neuesGeom = new Ellipse2D.Double();
					neuesGeom.setFrame(me.getPoint().getX(),me.getPoint().getY(),200.0,100.0);
					Zeichen_Object neuesObj = new Zeichen_Object(neuesGeom,aktuellerStroke,aktuelleFarbe,Grd_Color,textureColor);
					
					neuesObj.setAktuelleX_Koor(me.getX());
					neuesObj.setAktuelleY_Koor(me.getY());
					
					neuesObj.setAktuelleBreite(200.0);
					neuesObj.setAktuelleHoehe(100.0);
					
					neuesObj.setAktuellerDrehpunkt_X(neuesObj.getMyShape().getBounds2D().getX()+
														neuesObj.getMyShape().getBounds2D().getWidth()/2.0);
					neuesObj.setAktuellerDrehpunkt_Y(neuesObj.getMyShape().getBounds2D().getY()+
														neuesObj.getMyShape().getBounds2D().getHeight()/2.0);
																					
					if(antialiasing_On.isSelected())
						neuesObj.setAntiAliasing(1);
					else
						neuesObj.setAntiAliasing(0);
					
					if(dithering_On.isSelected())
						neuesObj.setDithering(1);
					else
						neuesObj.setDithering(0);
						
					if(rendering_Quality.isSelected())	
						neuesObj.setRender_Allgemein(1);
					else
						neuesObj.setRender_Allgemein(0);
					
						
					Zeichenbrett.getShape_Vektor().add(neuesObj);
					Zeichenbrett.setVisible(false);
					Zeichenbrett.setVisible(true);
					
					Grd_Color=0;
					textureColor=0;
					aktuelleFarbe=null;
				
					Ellipse.setSelected(false);
				}
		
				if(Kreis.isSelected())
				{
					Ellipse2D.Double neuesGeom = new Ellipse2D.Double();
					neuesGeom.setFrame(me.getPoint().getX(),me.getPoint().getY(),150.0,150.0);
					Zeichen_Object neuesObj = new Zeichen_Object(neuesGeom,aktuellerStroke,aktuelleFarbe,Grd_Color,textureColor);
					
					neuesObj.setAktuelleX_Koor(me.getX());
					neuesObj.setAktuelleY_Koor(me.getY());
					
					neuesObj.setAktuelleBreite(150.0);
					neuesObj.setAktuelleHoehe(150.0);
					
					neuesObj.setAktuellerDrehpunkt_X(neuesObj.getMyShape().getBounds2D().getX()+
														neuesObj.getMyShape().getBounds2D().getWidth()/2.0);
					neuesObj.setAktuellerDrehpunkt_Y(neuesObj.getMyShape().getBounds2D().getY()+
														neuesObj.getMyShape().getBounds2D().getHeight()/2.0);
																			
					if(antialiasing_On.isSelected())
						neuesObj.setAntiAliasing(1);
					else
						neuesObj.setAntiAliasing(0);
					
					if(dithering_On.isSelected())
						neuesObj.setDithering(1);
					else
						neuesObj.setDithering(0);
						
					if(rendering_Quality.isSelected())	
						neuesObj.setRender_Allgemein(1);
					else
						neuesObj.setRender_Allgemein(0);
					
					Zeichenbrett.getShape_Vektor().add(neuesObj);
					Zeichenbrett.setVisible(false);
					Zeichenbrett.setVisible(true);
					
					Grd_Color=0;
					textureColor=0;
					aktuelleFarbe=null;
					
					Kreis.setSelected(false);
				}
		
				if(Rechteck.isSelected())
				{
					Rectangle2D.Double neuesGeom = new Rectangle2D.Double();
					neuesGeom.setFrame(me.getPoint().getX(),me.getPoint().getY(),200.0,100.0);
					Zeichen_Object neuesObj = new Zeichen_Object(neuesGeom,aktuellerStroke,aktuelleFarbe,Grd_Color,textureColor);
					
					neuesObj.setAktuelleX_Koor(me.getX());
					neuesObj.setAktuelleY_Koor(me.getY());
					
					neuesObj.setAktuelleBreite(200.0);
					neuesObj.setAktuelleHoehe(100.0);
					
					neuesObj.setAktuellerDrehpunkt_X(neuesObj.getMyShape().getBounds2D().getX()+
														neuesObj.getMyShape().getBounds2D().getWidth()/2.0);
					neuesObj.setAktuellerDrehpunkt_Y(neuesObj.getMyShape().getBounds2D().getY()+
														neuesObj.getMyShape().getBounds2D().getHeight()/2.0);
																						
					if(antialiasing_On.isSelected())
						neuesObj.setAntiAliasing(1);
					else
						neuesObj.setAntiAliasing(0);
					
					if(dithering_On.isSelected())
						neuesObj.setDithering(1);
					else
						neuesObj.setDithering(0);
						
					if(rendering_Quality.isSelected())	
						neuesObj.setRender_Allgemein(1);
					else
						neuesObj.setRender_Allgemein(0);
						
					Zeichenbrett.getShape_Vektor().add(neuesObj);
					Zeichenbrett.setVisible(false);
					Zeichenbrett.setVisible(true);
					
					Grd_Color=0;
					textureColor=0;
					aktuelleFarbe=null;
					
					Rechteck.setSelected(false);
				}
			
				if(Rundes_Rechteck.isSelected())
				{
					RoundRectangle2D.Double neuesGeom = new RoundRectangle2D.Double(me.getPoint().getX(),me.getPoint().getY(),200.0,100.0,50.0,50.0);
					neuesGeom.setFrame(me.getPoint().getX(),me.getPoint().getY(),200.0,100.0);
					Zeichen_Object neuesObj = new Zeichen_Object(neuesGeom,aktuellerStroke,aktuelleFarbe,Grd_Color,textureColor);
					
					neuesObj.setAktuelleX_Koor(me.getX());
					neuesObj.setAktuelleY_Koor(me.getY());
					
					neuesObj.setAktuelleBreite(200.0);
					neuesObj.setAktuelleHoehe(100.0);
					
					neuesObj.setAktuellerDrehpunkt_X(neuesObj.getMyShape().getBounds2D().getX()+
														neuesObj.getMyShape().getBounds2D().getWidth()/2.0);
					neuesObj.setAktuellerDrehpunkt_Y(neuesObj.getMyShape().getBounds2D().getY()+
														neuesObj.getMyShape().getBounds2D().getHeight()/2.0);
																					
					if(antialiasing_On.isSelected())
						neuesObj.setAntiAliasing(1);
					else
						neuesObj.setAntiAliasing(0);
					
					if(dithering_On.isSelected())
						neuesObj.setDithering(1);
					else
						neuesObj.setDithering(0);
						
					if(rendering_Quality.isSelected())	
						neuesObj.setRender_Allgemein(1);
					else
						neuesObj.setRender_Allgemein(0);
						
					Zeichenbrett.getShape_Vektor().add(neuesObj);
					Zeichenbrett.setVisible(false);
					Zeichenbrett.setVisible(true);
					
					Grd_Color=0;
					textureColor=0;
					aktuelleFarbe=null;
					
					Rundes_Rechteck.setSelected(false);
				}
			
				if(Winkel.isSelected())
				{
					Arc2D.Double neuesGeom = new Arc2D.Double(me.getPoint().getX(),me.getPoint().getY(),100.0,100.0,45,270,Arc2D.PIE);
					neuesGeom.setFrame(me.getPoint().getX(),me.getPoint().getY(),150.0,150.0);
					Zeichen_Object neuesObj = new Zeichen_Object(neuesGeom,aktuellerStroke,aktuelleFarbe,Grd_Color,textureColor);
					
					neuesObj.setAktuelleX_Koor(me.getX());
					neuesObj.setAktuelleY_Koor(me.getY());
					
					neuesObj.setAktuelleBreite(150.0);
					neuesObj.setAktuelleHoehe(150.0);
					
					neuesObj.setAktuellerDrehpunkt_X(neuesObj.getMyShape().getBounds2D().getX()+
														neuesObj.getMyShape().getBounds2D().getWidth()/2.0);
					neuesObj.setAktuellerDrehpunkt_Y(neuesObj.getMyShape().getBounds2D().getY()+
														neuesObj.getMyShape().getBounds2D().getHeight()/2.0);
																			
					if(antialiasing_On.isSelected())
						neuesObj.setAntiAliasing(1);
					else
						neuesObj.setAntiAliasing(0);
					
					if(dithering_On.isSelected())
						neuesObj.setDithering(1);
					else
						neuesObj.setDithering(0);
						
					if(rendering_Quality.isSelected())	
						neuesObj.setRender_Allgemein(1);
					else
						neuesObj.setRender_Allgemein(0);
						
					Zeichenbrett.getShape_Vektor().add(neuesObj);
					Zeichenbrett.setVisible(false);
					Zeichenbrett.setVisible(true);
					
					Grd_Color=0;
					textureColor=0;
					aktuelleFarbe=null;
					Winkel.setSelected(false);
					
				}
			
				if(Linie.isSelected())
				{
					if(Anfangspunkt_Linie==null)
						Anfangspunkt_Linie=me.getPoint();
					else
					{
						Line2D.Double neuesGeom = new Line2D.Double(Anfangspunkt_Linie,me.getPoint());				
							
						Zeichen_Object neuesObj = new Zeichen_Object(neuesGeom,aktuellerStroke,aktuelleFarbe,Grd_Color,textureColor);
						
						if(antialiasing_On.isSelected())
							neuesObj.setAntiAliasing(1);
						else
							neuesObj.setAntiAliasing(0);
					
						if(dithering_On.isSelected())
							neuesObj.setDithering(1);
						else
							neuesObj.setDithering(0);
						
						if(rendering_Quality.isSelected())	
							neuesObj.setRender_Allgemein(1);
						else
							neuesObj.setRender_Allgemein(0);
					
						Zeichenbrett.getShape_Vektor().add(neuesObj);
						Zeichenbrett.setVisible(false);
						Zeichenbrett.setVisible(true);
							
						Grd_Color=0;
						textureColor=0;
						aktuelleFarbe=null;
						Anfangspunkt_Linie=null;
						
						Linie.setSelected(false);
					}
				
				}
			
				if(GP.isSelected())
				{
					if(GP_Vector.size()<5)
					{
					Point neuerpunkt = me.getPoint();
					GP_Vector.add(neuerpunkt);
					}
					else
					{
						GeneralPath neuesGeom = new GeneralPath(GeneralPath.WIND_EVEN_ODD,GP_Vector.size());
						neuesGeom.moveTo((float)((Point)GP_Vector.elementAt(0)).getX(),
										(float)((Point)GP_Vector.elementAt(0)).getY());
						
						for(int i=1;i<GP_Vector.size();i++)
						{
							neuesGeom.lineTo((float)((Point)GP_Vector.elementAt(i)).getX(),
										(float)((Point)GP_Vector.elementAt(i)).getY());	
						}
					
						neuesGeom.closePath();
						
						Zeichen_Object neuesObj = new Zeichen_Object(neuesGeom,aktuellerStroke,aktuelleFarbe,Grd_Color,textureColor);
						
						neuesObj.setAktuelleBreite(neuesObj.getMyShape().getBounds2D().getWidth());
						neuesObj.setAktuelleHoehe(neuesObj.getMyShape().getBounds2D().getHeight());
					
						neuesObj.setAktuellerDrehpunkt_X(neuesObj.getMyShape().getBounds2D().getX()+
														neuesObj.getMyShape().getBounds2D().getWidth()/2.0);
						neuesObj.setAktuellerDrehpunkt_Y(neuesObj.getMyShape().getBounds2D().getY()+
														neuesObj.getMyShape().getBounds2D().getHeight()/2.0);
																			
						if(antialiasing_On.isSelected())
							neuesObj.setAntiAliasing(1);
						else
							neuesObj.setAntiAliasing(0);
						
						if(dithering_On.isSelected())
							neuesObj.setDithering(1);
						else
							neuesObj.setDithering(0);
							
						if(rendering_Quality.isSelected())	
							neuesObj.setRender_Allgemein(1);
						else
							neuesObj.setRender_Allgemein(0);
							
						Zeichenbrett.getShape_Vektor().add(neuesObj);
						Zeichenbrett.setVisible(false);
						Zeichenbrett.setVisible(true);
							
						Grd_Color=0;
						textureColor=0;
						aktuelleFarbe=null;
						Anfangspunkt_Linie=null;
						
						GP_Vector.removeAllElements();
					}
				}
			}
			
			else
			{
				if(Zeichenbrett.getShape_Vektor().size()>0)
				{
				for(int i=0;i<Zeichenbrett.getShape_Vektor().size();i++)
				{
					if(((Shape)((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getMyShape()).contains(me.getPoint()))
					{	
						((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).setIstSelektiert(
							!((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).isIstSelektiert());
					}	
				}
				Zeichenbrett.setVisible(false);
				Zeichenbrett.setVisible(true);
				}
			}
		}
	
	});

	RenderingGschichten = new JPanel();
	RenderingGschichten.setBackground(Color.BLACK);
	RenderingGschichten.setBorder(BorderFactory.createBevelBorder(
		BevelBorder.LOWERED,Color.WHITE,Color.WHITE));
	
	RenderingTitel = new JLabel(new ImageIcon("Bilderchen/Titel_Rendering.jpg"));
	
	/* Allgemeine Rendereinstellungen*/
	
	Allg_Ren_Titel = new JLabel(new ImageIcon("Bilderchen/All_Ren_Titel.jpg"));
	//Allg_Ren_Titel.setHorizontalAlignment(SwingConstants.LEFT);
	
	rendering_Schnell= new JRadioButton(new ImageIcon("Bilderchen/Speed.jpg"));
	rendering_Schnell.setSelectedIcon(new ImageIcon("Bilderchen/Speed_Selected.jpg"));
	rendering_Schnell.setDisabledIcon(new ImageIcon("Bilderchen/Speed.jpg"));
	rendering_Schnell.setBorder(null);
	
	rendering_Quality = new JRadioButton(new ImageIcon("Bilderchen/Quality.jpg"));;
	rendering_Quality.setSelectedIcon(new ImageIcon("Bilderchen/Quality_Selected.jpg"));
	rendering_Quality.setDisabledIcon(new ImageIcon("Bilderchen/Quality.jpg"));
	rendering_Quality.setBorder(null);
	rendering_Quality.setSelected(true);
	
	bg_rendering = new ButtonGroup();
	bg_rendering.add(rendering_Schnell);
	bg_rendering.add(rendering_Quality);
	
	allgemeines_rendering = new JPanel();

	antialiasing_Titel = new JLabel(new ImageIcon("Bilderchen/AntiAliasing_Titel.jpg"));

	
	antialiasing_On = new JRadioButton(new ImageIcon("Bilderchen/On.jpg"));
	antialiasing_On.setSelectedIcon(new ImageIcon("Bilderchen/On_Selected.jpg"));
	antialiasing_On.setDisabledIcon(new ImageIcon("Bilderchen/On.jpg"));
	antialiasing_On.setBorder(null);
	
	antialiasing_Off = new JRadioButton(new ImageIcon("Bilderchen/Off.jpg"));;
	antialiasing_Off.setSelectedIcon(new ImageIcon("Bilderchen/Off_Selected.jpg"));
	antialiasing_Off.setDisabledIcon(new ImageIcon("Bilderchen/Off.jpg"));
	antialiasing_Off.setBorder(null);
	antialiasing_Off.setSelected(true);
	
	bg_antialiasing = new ButtonGroup();
	bg_antialiasing.add(antialiasing_On);
	bg_antialiasing.add(antialiasing_Off);
	
	anti_aliasing_panel = new JPanel();

	dithering_panel= new JPanel();
	
	Dithering_Titel = new JLabel(new ImageIcon("Bilderchen/Dithering_Titel.jpg"));
	
	dithering_On = new JRadioButton(new ImageIcon("Bilderchen/On.jpg"));
	dithering_On.setSelectedIcon(new ImageIcon("Bilderchen/On_Selected.jpg"));
	dithering_On.setDisabledIcon(new ImageIcon("Bilderchen/On.jpg"));
	dithering_On.setBorder(null);
	
	dithering_Off = new JRadioButton(new ImageIcon("Bilderchen/Off.jpg"));;
	dithering_Off.setSelectedIcon(new ImageIcon("Bilderchen/Off_Selected.jpg"));
	dithering_Off.setDisabledIcon(new ImageIcon("Bilderchen/Off.jpg"));
	dithering_Off.setBorder(null);
	dithering_Off.setSelected(true);
	
	bg_dithering = new ButtonGroup();
	bg_dithering.add(dithering_On);
	bg_dithering.add(dithering_Off);
	
	
	/* RendernigPanel erschaffen unfd fuellen*/
	
	this.add(RenderingTitel);
	this.add(Allg_Ren_Titel);
	this.add(rendering_Schnell);
	this.add(rendering_Quality);
	this.add(antialiasing_Titel);
	this.add(antialiasing_On);
	this.add(antialiasing_Off);
	this.add(Dithering_Titel);
	this.add(dithering_On);
	this.add(dithering_Off);
	
	/* ************* Allgemeine Optionen ******************* */
	
	neuesBlatt = new JButton(new ImageIcon("Bilderchen/neu.jpg"));
	neuesBlatt.setPressedIcon(new ImageIcon("Bilderchen/neu_Pressed.jpg"));
	neuesBlatt.setBackground(Color.BLACK);
	neuesBlatt.setBorder(null);
	neuesBlatt.setToolTipText("Neu");
	neuesBlatt.addActionListener(new ActionListener(){
	
		public void actionPerformed(ActionEvent e)
		{
			Zeichenbrett.getShape_Vektor().removeAllElements();
			malModus.doClick();
			Zeichenbrett.setVisible(false);
			Zeichenbrett.setVisible(true);
		}
		
	});
	
	this.add(neuesBlatt);
	
	
	editModus = new JRadioButton(new ImageIcon("Bilderchen/edit_modus.jpg"));
	editModus.setSelectedIcon(new ImageIcon("Bilderchen/edit_modus_Selected.jpg"));
	editModus.setBorder(null);
	editModus.setBackground(Color.BLACK);
	editModus.setToolTipText("EditierModus");
	editModus.addActionListener(new ActionListener(){
	
		public void actionPerformed(ActionEvent e)
		{
		
		}
		
	});
	this.add(editModus);
	
	malModus = new JRadioButton(new ImageIcon("Bilderchen/draw_modus.jpg"));
	malModus.setSelectedIcon(new ImageIcon("Bilderchen/draw_modus_Selected.jpg"));
	malModus.setBorder(null);
	malModus.setBackground(Color.BLACK);
	malModus.setSelected(true);
	malModus.setToolTipText("ZeichenModus");
	malModus.addActionListener(new ActionListener(){
	
		public void actionPerformed(ActionEvent e)
		{
			for(int i=0;i<Zeichenbrett.getShape_Vektor().size();i++)
			{
				((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).setIstSelektiert(false);
			}
		Zeichenbrett.setVisible(false);
		Zeichenbrett.setVisible(true);
		}
		
	});
	
	this.add(malModus);
	
	bg_moduswahl = new ButtonGroup();
	
	bg_moduswahl.add(editModus);
	bg_moduswahl.add(malModus);
	
	basisAuswahl = new JPanel();
	basisAuswahl.setBorder(BorderFactory.createBevelBorder(
		BevelBorder.LOWERED,Color.WHITE,Color.WHITE));
	basisAuswahl.setBackground(Color.BLACK);
	
	this.add(basisAuswahl);	
	
		
	/* ************* shapeManipulation ********************* */
	
	zoom_in = new JButton(new ImageIcon("Bilderchen/Zoom_in.jpg"));
	zoom_in.setPressedIcon(new ImageIcon("Bilderchen/Zoom_in_Pressed.jpg"));
	zoom_in.setBackground(Color.BLACK);
	zoom_in.setBorder(null);
	zoom_in.addActionListener(new ActionListener()
	{
	
		public void actionPerformed(ActionEvent e)
		{
		for(int i=0;i<Zeichenbrett.getShape_Vektor().size();i++)
			{
				if(((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).isIstSelektiert())
				{
																	
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getMy_Scale_AT().concatenate(
					AffineTransform.getScaleInstance(2.0,2.0));
					
							
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getMy_Translate_AT().concatenate(
						AffineTransform.getTranslateInstance(
						-((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuelleX_Koor()
						,-((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuelleY_Koor()));
					
					
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).setAktuelleX_Koor(
						2*((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuelleX_Koor());
					
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).setAktuelleY_Koor(
						2*((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuelleY_Koor());	
					
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).setAktuelleBreite(
						2*((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuelleBreite());
					
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).setAktuelleHoehe(
						2*((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuelleHoehe());
					
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).setAktuellerDrehpunkt_X(
						((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getMyShape().getBounds2D().getX()+
						((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuelleBreite()/2);
					
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).setAktuellerDrehpunkt_Y(
						((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getMyShape().getBounds2D().getY()+
						((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuelleHoehe()/2);
							
					/*((Arc2D)((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getMyShape()).setFrame(
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuelleX_Koor(),
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuelleY_Koor(),
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getMyShape().getBounds2D().getWidth(),
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getMyShape().getBounds2D().getHeight());*/
				}
			}
		Zeichenbrett.setVisible(false);
		Zeichenbrett.setVisible(true);
		}
		
	});
	
	this.add(zoom_in);
	
	zoom_out = new JButton(new ImageIcon("Bilderchen/Zoom_out.jpg"));
	zoom_out.setPressedIcon(new ImageIcon("Bilderchen/Zoom_out_Pressed.jpg"));
	zoom_out.setBackground(Color.BLACK);
	zoom_out.setBorder(null);
	zoom_out.addActionListener(new ActionListener(){
	
		public void actionPerformed(ActionEvent e)
		{
		for(int i=0;i<Zeichenbrett.getShape_Vektor().size();i++)
			{
				if(((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).isIstSelektiert())
				{
					
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getMy_Scale_AT().concatenate(
					AffineTransform.getScaleInstance(0.5,0.5));
						
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getMy_Translate_AT().concatenate(
					AffineTransform.getTranslateInstance(
						0.5*((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuelleX_Koor()
						,0.5*((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuelleY_Koor()));
				
					
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).setAktuelleX_Koor(
							((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuelleX_Koor()*0.5);
					
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).setAktuelleY_Koor(
						
						((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuelleY_Koor()*0.5);	
				
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).setAktuelleBreite(
						0.5*((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuelleBreite());
					
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).setAktuelleHoehe(
						0.5*((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuelleHoehe());
					
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).setAktuellerDrehpunkt_X(
						((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getMyShape().getBounds2D().getX()+
						((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuelleBreite()/2);
					
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).setAktuellerDrehpunkt_Y(
						((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getMyShape().getBounds2D().getY()+
						((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuelleHoehe()/2);
				}
			}
		Zeichenbrett.setVisible(false);
		Zeichenbrett.setVisible(true);
		}
		
	});
	this.add(zoom_out);
	
	rotate_left = new JButton(new ImageIcon("Bilderchen/rotate_left.jpg"));
	rotate_left.setPressedIcon(new ImageIcon("Bilderchen/rotate_left_Pressed.jpg"));
	rotate_left.setBackground(Color.BLACK);
	rotate_left.setBorder(null);
	rotate_left.addActionListener(new ActionListener(){
	
		public void actionPerformed(ActionEvent e)
		{
		for(int i=0;i<Zeichenbrett.getShape_Vektor().size();i++)
			{
				if(((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).isIstSelektiert())
				{
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getMy_Rotate_AT().concatenate(
					AffineTransform.getRotateInstance(-(Math.PI/6.0),
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuellerDrehpunkt_X(),
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuellerDrehpunkt_Y()
					));
				}
			}
		Zeichenbrett.setVisible(false);
		Zeichenbrett.setVisible(true);
		}
		
	});
	this.add(rotate_left);
	
	rotate_right = new JButton(new ImageIcon("Bilderchen/rotate_right.jpg"));
	rotate_right.setPressedIcon(new ImageIcon("Bilderchen/rotate_right_Pressed.jpg"));
	rotate_right.setBackground(Color.BLACK);
	rotate_right.setBorder(null);
	rotate_right.addActionListener(new ActionListener(){
	
		public void actionPerformed(ActionEvent e)
		{
		for(int i=0;i<Zeichenbrett.getShape_Vektor().size();i++)
			{
				if(((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).isIstSelektiert())
				{
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getMy_Rotate_AT().concatenate(
					AffineTransform.getRotateInstance(Math.PI/6.0,
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuellerDrehpunkt_X(),
					((Zeichen_Object)(Zeichenbrett.getShape_Vektor().elementAt(i))).getAktuellerDrehpunkt_Y()
					));
				}
			}
		Zeichenbrett.setVisible(false);
		Zeichenbrett.setVisible(true);
		}
		
	});
	this.add(rotate_right);
	

	
	manipulationsPanel = new JPanel();
	manipulationsPanel.setBorder(BorderFactory.createBevelBorder(
		BevelBorder.LOWERED,Color.WHITE,Color.WHITE));
	manipulationsPanel.setBackground(Color.BLACK);
	
	this.add(manipulationsPanel);
	
	/* ********************************************** */
	
	ButtonPanel_Geometrische_Bearbeitung= new JPanel();
	ButtonPanel_Geometrische_Bearbeitung.setBackground(Color.BLACK);
	ButtonPanel_Geometrische_Bearbeitung.setBorder(BorderFactory.createBevelBorder(
		BevelBorder.LOWERED,Color.WHITE,Color.WHITE));
	ButtonPanel_Geometrische_Bearbeitung.setOpaque(false);
	
	ButtonPanel_Rendering_Parameter= new JPanel();
	ButtonPanel_Rendering_Parameter.setBackground(Color.GREEN);
	
	ButtonPanel_Zeichnung_Einstellungen= new JPanel();
	ButtonPanel_Zeichnung_Einstellungen.setLayout(new GridLayout(2,1));
	ButtonPanel_Zeichnung_Einstellungen.setBackground(Color.BLACK);
	ButtonPanel_Zeichnung_Einstellungen.setBorder(BorderFactory.createBevelBorder(
		BevelBorder.LOWERED,Color.WHITE,Color.WHITE));
	
	
	Strokewahl = new JPanel();
	Strokewahl.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED 
			,Color.WHITE,Color.WHITE));
	Strokewahl.setLayout(new GridLayout(3,1));
	Strokewahl.setBackground(Color.BLACK);
	
	welches_Schweinderl_haettens_denn_gerne = new ButtonGroup();
	
	rot = new JRadioButton(new ImageIcon("Bilderchen/red.jpg"));
	rot.setSelectedIcon(new ImageIcon("Bilderchen/red_Selected.jpg"));
	rot.setDisabledIcon(new ImageIcon("Bilderchen/red.jpg"));
	rot.setBackground(Color.BLACK);
	
	
	gruen = new JRadioButton(new ImageIcon("Bilderchen/green.jpg"));
	gruen.setBackground(Color.BLACK);
	gruen.setSelectedIcon(new ImageIcon("Bilderchen/green_Selected.jpg"));
	gruen.setDisabledIcon(new ImageIcon("Bilderchen/green.jpg"));
	
	gelb = new JRadioButton(new ImageIcon("Bilderchen/yellow.jpg"));
	gelb.setBackground(Color.BLACK);
	gelb.setSelectedIcon(new ImageIcon("Bilderchen/yellow_Selected.jpg"));
	gelb.setDisabledIcon(new ImageIcon("Bilderchen/yellow.jpg"));
	
	blau = new JRadioButton(new ImageIcon("Bilderchen/blue.jpg"));
	blau.setBackground(Color.BLACK);
	blau.setSelectedIcon(new ImageIcon("Bilderchen/blue_Selected.jpg"));
	blau.setDisabledIcon(new ImageIcon("Bilderchen/blue_Selected.jpg"));
	
	orange = new JRadioButton(new ImageIcon("Bilderchen/orange.jpg"));
	orange.setBackground(Color.BLACK);
	orange.setSelectedIcon(new ImageIcon("Bilderchen/orange_Selected.jpg"));
	orange.setDisabledIcon(new ImageIcon("Bilderchen/orange.jpg"));
	
	pink = new JRadioButton(new ImageIcon("Bilderchen/pink.jpg"));
	pink.setBackground(Color.BLACK);
	pink.setSelectedIcon(new ImageIcon("Bilderchen/pink_Selected.jpg"));
	pink.setDisabledIcon(new ImageIcon("Bilderchen/pink.jpg"));
	
	grad_rot_schwarz = new JRadioButton(new ImageIcon("Bilderchen/gradient_red_black.jpg"));
	grad_rot_schwarz.setHorizontalAlignment(SwingConstants.CENTER);
	grad_rot_schwarz.setBackground(Color.BLACK);
	grad_rot_schwarz.setSelectedIcon(new ImageIcon("Bilderchen/gradient_red_black_Selected.jpg"));
	grad_rot_schwarz.setDisabledIcon(new ImageIcon("Bilderchen/gradient_red_black.jpg"));
	
	grad_gruen_gelb = new JRadioButton(new ImageIcon("Bilderchen/gradient_green_yellow.jpg"));
	grad_gruen_gelb.setHorizontalAlignment(SwingConstants.CENTER);
	grad_gruen_gelb.setBackground(Color.BLACK);
	grad_gruen_gelb.setSelectedIcon(new ImageIcon("Bilderchen/gradient_green_yellow_Selected.jpg"));
	grad_gruen_gelb.setDisabledIcon(new ImageIcon("Bilderchen/gradient_green_yellow.jpg"));
	
	grad_blau_rot = new JRadioButton(new ImageIcon("Bilderchen/gradient_blue_red.jpg"));
	grad_blau_rot.setHorizontalAlignment(SwingConstants.CENTER);
	grad_blau_rot.setBackground(Color.BLACK);
	grad_blau_rot.setSelectedIcon(new ImageIcon("Bilderchen/gradient_blue_red_Selected.jpg"));
	grad_blau_rot.setDisabledIcon(new ImageIcon("Bilderchen/gradient_blue_red.jpg"));
	
	texturepaint_1 = new JRadioButton(new ImageIcon("Bilderchen/texturepaint_1.jpg"));
	texturepaint_1.setHorizontalAlignment(SwingConstants.CENTER);
	texturepaint_1.setBackground(Color.BLACK);
	texturepaint_1.setSelectedIcon(new ImageIcon("Bilderchen/texturepaint_1_Selected.jpg"));
	texturepaint_1.setDisabledIcon(new ImageIcon("Bilderchen/texturepaint_1.jpg"));
	
	welches_Schweinderl_haettens_denn_gerne.add(rot);
	welches_Schweinderl_haettens_denn_gerne.add(gruen);
	welches_Schweinderl_haettens_denn_gerne.add(gelb);
	welches_Schweinderl_haettens_denn_gerne.add(blau);
	welches_Schweinderl_haettens_denn_gerne.add(orange);
	welches_Schweinderl_haettens_denn_gerne.add(pink);
	welches_Schweinderl_haettens_denn_gerne.add(grad_blau_rot);
	welches_Schweinderl_haettens_denn_gerne.add(grad_gruen_gelb);
	welches_Schweinderl_haettens_denn_gerne.add(grad_rot_schwarz);
	welches_Schweinderl_haettens_denn_gerne.add(texturepaint_1);
	
	normFarbe = new JPanel();
	
	normFarbe.setLayout(new GridLayout(3,2));
	normFarbe.setBackground(Color.BLACK);
	normFarbe.add(rot);
	normFarbe.add(gruen);
	normFarbe.add(gelb);
	normFarbe.add(blau);
	normFarbe.add(orange);
	normFarbe.add(pink);
	
	gradFarbe = new JPanel();
	gradFarbe.setLayout(new GridLayout(4,1));
	gradFarbe.setBackground(Color.BLACK);
	gradFarbe.add(grad_blau_rot);
	gradFarbe.add(grad_gruen_gelb);
	gradFarbe.add(grad_rot_schwarz);
	gradFarbe.add(texturepaint_1);
	
	Farbwahl = new JPanel();
	Farbwahl.setLayout(new GridLayout(2,1));
	Farbwahl.setBorder(BorderFactory.createBevelBorder(
		BevelBorder.LOWERED,Color.WHITE,Color.WHITE));
	Farbwahl.setBackground(Color.BLACK);
	Farbwahl.add(normFarbe);
	Farbwahl.add(gradFarbe);
	
	/* Definieren des Panels fr die Stroke-Attribute*/
	
	wie_dick_mog_as_denn = new ButtonGroup();
	
	strichst_1 = new JRadioButton(new ImageIcon("Bilderchen/Strichdicke_1.jpg"));
	strichst_1.setSelectedIcon(new ImageIcon("Bilderchen/Strichdicke_1_Selected.jpg"));
	strichst_1.setDisabledIcon(new ImageIcon("Bilderchen/Strichdicke_1.jpg"));
	strichst_1.setBackground(Color.BLACK);
	strichst_1.setSelected(true);
	strichst_1.addActionListener(new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
		aktuellerStroke = b1;
		}
	});
	
	strichst_2 = new JRadioButton(new ImageIcon("Bilderchen/Strichdicke_2.jpg"));
	strichst_2.setSelectedIcon(new ImageIcon("Bilderchen/Strichdicke_2_Selected.jpg"));
	strichst_2.setDisabledIcon(new ImageIcon("Bilderchen/Strichdicke_2.jpg"));
	strichst_2.setBackground(Color.BLACK);
	strichst_2.addActionListener(new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
		aktuellerStroke = b2;
		}
	});
	
	strichst_3 = new JRadioButton(new ImageIcon("Bilderchen/Strichbreite_3.jpg"));
	strichst_3.setSelectedIcon(new ImageIcon("Bilderchen/Strichbreite_3_Selected.jpg"));
	strichst_3.setDisabledIcon(new ImageIcon("Bilderchen/Strichbreite_3.jpg"));
	strichst_3.setBackground(Color.BLACK);
	strichst_3.addActionListener(new ActionListener()
	{
		public void actionPerformed(ActionEvent e)
		{
		aktuellerStroke = b3;
		}
	});
	
	wie_dick_mog_as_denn.add(strichst_1);
	wie_dick_mog_as_denn.add(strichst_2);
	wie_dick_mog_as_denn.add(strichst_3);
	
	Strokewahl.add(strichst_1);
	Strokewahl.add(strichst_2);
	Strokewahl.add(strichst_3);
	
	/* Definieren des Panels mit den geometrischen Primitiven */
		
	was_Will_Der_Trottel_Malen = new ButtonGroup();
	
	Ellipse = new JRadioButton(new ImageIcon("Bilderchen/Ellipse2D.jpg"));
	Ellipse.setSelectedIcon(new ImageIcon("Bilderchen/Ellipse2D_Selected.jpg"));
	Ellipse.setDisabledIcon(new ImageIcon("Bilderchen/Ellipse2D.jpg"));
	Ellipse.setBackground(Color.BLACK);
	Ellipse.setToolTipText("Ellipse");
	
	Kreis = new JRadioButton(new ImageIcon("Bilderchen/Circle.jpg"));
	Kreis.setBackground(Color.BLACK);
	Kreis.setSelectedIcon(new ImageIcon("Bilderchen/Circle_Selected.jpg"));
	Kreis.setDisabledIcon(new ImageIcon("Bilderchen/Circle.jpg"));
	Kreis.setToolTipText("Kreis");
	
	Rechteck = new JRadioButton(new ImageIcon("Bilderchen/Rectangle.jpg"));
	Rechteck.setBackground(Color.BLACK);
	Rechteck.setSelectedIcon(new ImageIcon("Bilderchen/Rectangle_Selected.jpg"));
	Rechteck.setDisabledIcon(new ImageIcon("Bilderchen/Rectangle.jpg"));
	Rechteck.setToolTipText("Rechteck");
	
	Rundes_Rechteck = new JRadioButton(new ImageIcon("Bilderchen/RoundRectangle.jpg"));
	Rundes_Rechteck.setBackground(Color.BLACK);
	Rundes_Rechteck.setSelectedIcon(new ImageIcon("Bilderchen/RoundRectangle_Selected.jpg"));
	Rundes_Rechteck.setDisabledIcon(new ImageIcon("Bilderchen/RoundRectangle.jpg"));
	Rundes_Rechteck.setToolTipText("Rundes Rechteck");
	
	Winkel = new JRadioButton(new ImageIcon("Bilderchen/Arc2D.jpg"));
	Winkel.setBackground(Color.BLACK);
	Winkel.setDisabledIcon(new ImageIcon("Bilderchen/Arc2D.jpg"));
	Winkel.setSelectedIcon(new ImageIcon("Bilderchen/Arc2D_Selected.jpg"));
	Winkel.setToolTipText("Winkel");
	
	Linie = new JRadioButton(new ImageIcon("Bilderchen/Line.jpg"));
	Linie.setBackground(Color.BLACK);
	Linie.setSelectedIcon(new ImageIcon("Bilderchen/Line_Selected.jpg"));
	Linie.setDisabledIcon(new ImageIcon("Bilderchen/Line.jpg"));
	Linie.setToolTipText("Linie");
		
	GP = new JRadioButton(new ImageIcon("Bilderchen/GeneralPath.jpg"));
	GP.setBackground(Color.BLACK);
	GP.setDisabledIcon(new ImageIcon("Bilderchen/GeneralPath.jpg"));
	GP.setSelectedIcon(new ImageIcon("Bilderchen/GeneralPath_Selected.jpg"));
	GP.setToolTipText("GeneralPath");
	
	was_Will_Der_Trottel_Malen.add(Ellipse);
	was_Will_Der_Trottel_Malen.add(Kreis);
	was_Will_Der_Trottel_Malen.add(Rechteck);
	was_Will_Der_Trottel_Malen.add(Rundes_Rechteck);
	was_Will_Der_Trottel_Malen.add(Winkel);
	was_Will_Der_Trottel_Malen.add(Linie);
	was_Will_Der_Trottel_Malen.add(GP);
	
	ButtonPanel_Geometrische_Bearbeitung.add(Ellipse);
	ButtonPanel_Geometrische_Bearbeitung.add(Kreis);
	ButtonPanel_Geometrische_Bearbeitung.add(Rechteck);
	ButtonPanel_Geometrische_Bearbeitung.add(Rundes_Rechteck);
	ButtonPanel_Geometrische_Bearbeitung.add(Winkel);
	ButtonPanel_Geometrische_Bearbeitung.add(Linie);
	ButtonPanel_Geometrische_Bearbeitung.add(GP);
	
	/*Defnintion des AuswahlPanels zum Aktivieren der Fill + Stroke Attribute*/
	
	Stroke = new JButton(new ImageIcon("Bilderchen/StrokeWidth.jpg"));
	Stroke.setPressedIcon(new ImageIcon("Bilderchen/StrokeWidth_Pressed.jpg"));
	Stroke.setDisabledIcon(new ImageIcon("Bilderchen/StrokeWidth.jpg"));
	Stroke.setBackground(Color.BLACK);
	Stroke.setToolTipText("Strichstrke");
	Stroke.setBorder(null);
	Stroke.addActionListener(new ActionListener(){
		
		public void actionPerformed(ActionEvent e)
		{
		braucheStrichAttribute = !braucheStrichAttribute;
		setVisible(false);
		setVisible(true);
		}
	});
	
	Fill = new JButton(new ImageIcon("Bilderchen/Paint.jpg"));
	Fill.setPressedIcon(new ImageIcon("Bilderchen/Paint_Pressed.jpg"));
	Fill.setBackground(Color.BLACK);
	Fill.setToolTipText("Fllfarbe");
	Fill.setBorder(null);
	Fill.addActionListener(new ActionListener(){
		
		public void actionPerformed(ActionEvent e1)
		{
		braucheFuellAttribute = !braucheFuellAttribute;
		setVisible(false);
		setVisible(true);
		}
	});
	
	ButtonPanel_Zeichnung_Einstellungen.add(Stroke);
	ButtonPanel_Zeichnung_Einstellungen.add(Fill);
	ButtonPanel_Zeichnung_Einstellungen.setBackground(Color.BLACK);
	
	this.add(Farbwahl);
	this.add(Strokewahl);
	this.add(RenderingGschichten);
	this.add(ButtonPanel_Geometrische_Bearbeitung);
	this.add(ButtonPanel_Zeichnung_Einstellungen);
	this.add(Zeichenbrett);
	
	this.setBackground(Color.BLACK);
	} 
	
	
	public static void main(String [] args)
	{
	JFrame frame = new JFrame("Malkasten");
	frame.addWindowListener(new WindowAdapter() 
        {
            public void windowClosing(WindowEvent e) {System.exit(0);}
        });
    Malkasten applet = new Malkasten();
    frame.getContentPane().add(applet);
    frame.pack();
    frame.setSize(new Dimension(800,630));
    frame.show();
	}

	
	
	/**
	 * Returns the buttonPanel_Geometrische_Bearbeitung.
	 * @return JPanel
	 */
	public JPanel getButtonPanel_Geometrische_Bearbeitung() {
		return ButtonPanel_Geometrische_Bearbeitung;
	}

	/**
	 * Returns the buttonPanel_Rendering_Parameter.
	 * @return JPanel
	 */
	public JPanel getButtonPanel_Rendering_Parameter() {
		return ButtonPanel_Rendering_Parameter;
	}

	/**
	 * Returns the buttonPanel_Zeichnung_Einstellungen.
	 * @return JPanel
	 */
	public JPanel getButtonPanel_Zeichnung_Einstellungen() {
		return ButtonPanel_Zeichnung_Einstellungen;
	}

	
	/**
	 * Returns the ellipse.
	 * @return JRadioButton
	 */
	public JRadioButton getEllipse() {
		return Ellipse;
	}

	/**
	 * Returns the GP.
	 * @return JRadioButton
	 */
	public JRadioButton getGP() {
		return GP;
	}

	/**
	 * Returns the hauptPanel.
	 * @return JPanel
	 */
	public JPanel getHauptPanel() {
		return HauptPanel;
	}

	/**
	 * Returns the kreis.
	 * @return JRadioButton
	 */
	public JRadioButton getKreis() {
		return Kreis;
	}

	/**
	 * Returns the linie.
	 * @return JRadioButton
	 */
	public JRadioButton getLinie() {
		return Linie;
	}

	/**
	 * Returns the rechteck.
	 * @return JRadioButton
	 */
	public JRadioButton getRechteck() {
		return Rechteck;
	}


	/**
	 * Returns the rundes_Rechteck.
	 * @return JRadioButton
	 */
	public JRadioButton getRundes_Rechteck() {
		return Rundes_Rechteck;
	}



	/**
	 * Returns the was_Will_Der_Trottel_Malen.
	 * @return ButtonGroup
	 */
	public ButtonGroup getWas_Will_Der_Trottel_Malen() {
		return was_Will_Der_Trottel_Malen;
	}

	/**
	 * Returns the winkel.
	 * @return JRadioButton
	 */
	public JRadioButton getWinkel() {
		return Winkel;
	}

	/**
	 * Returns the zeichenbrett.
	 * @return ZeichenbrettPanel
	 */
	public ZeichenbrettPanel getZeichenbrett() {
		return Zeichenbrett;
	}

	
	/**
	 * Sets the buttonPanel_Geometrische_Bearbeitung.
	 * @param buttonPanel_Geometrische_Bearbeitung The buttonPanel_Geometrische_Bearbeitung to set
	 */
	public void setButtonPanel_Geometrische_Bearbeitung(JPanel buttonPanel_Geometrische_Bearbeitung) {
		ButtonPanel_Geometrische_Bearbeitung =
			buttonPanel_Geometrische_Bearbeitung;
	}

	/**
	 * Sets the buttonPanel_Rendering_Parameter.
	 * @param buttonPanel_Rendering_Parameter The buttonPanel_Rendering_Parameter to set
	 */
	public void setButtonPanel_Rendering_Parameter(JPanel buttonPanel_Rendering_Parameter) {
		ButtonPanel_Rendering_Parameter = buttonPanel_Rendering_Parameter;
	}

	/**
	 * Sets the buttonPanel_Zeichnung_Einstellungen.
	 * @param buttonPanel_Zeichnung_Einstellungen The buttonPanel_Zeichnung_Einstellungen to set
	 */
	public void setButtonPanel_Zeichnung_Einstellungen(JPanel buttonPanel_Zeichnung_Einstellungen) {
		ButtonPanel_Zeichnung_Einstellungen =
			buttonPanel_Zeichnung_Einstellungen;
	}

	
	/**
	 * Sets the ellipse.
	 * @param ellipse The ellipse to set
	 */
	public void setEllipse(JRadioButton ellipse) {
		Ellipse = ellipse;
	}

	/**
	 * Sets the GP.
	 * @param GP The GP to set
	 */
	public void setGP(JRadioButton GP) {
		GP = GP;
	}

	/**
	 * Sets the hauptPanel.
	 * @param hauptPanel The hauptPanel to set
	 */
	public void setHauptPanel(JPanel hauptPanel) {
		HauptPanel = hauptPanel;
	}

	/**
	 * Sets the kreis.
	 * @param kreis The kreis to set
	 */
	public void setKreis(JRadioButton kreis) {
		Kreis = kreis;
	}

	/**
	 * Sets the linie.
	 * @param linie The linie to set
	 */
	public void setLinie(JRadioButton linie) {
		Linie = linie;
	}

	/**
	 * Sets the rechteck.
	 * @param rechteck The rechteck to set
	 */
	public void setRechteck(JRadioButton rechteck) {
		Rechteck = rechteck;
	}

	

	/**
	 * Sets the rundes_Rechteck.
	 * @param rundes_Rechteck The rundes_Rechteck to set
	 */
	public void setRundes_Rechteck(JRadioButton rundes_Rechteck) {
		Rundes_Rechteck = rundes_Rechteck;
	}



	/**
	 * Sets the was_Will_Der_Trottel_Malen.
	 * @param was_Will_Der_Trottel_Malen The was_Will_Der_Trottel_Malen to set
	 */
	public void setWas_Will_Der_Trottel_Malen(ButtonGroup was_Will_Der_Trottel_Malen) {
		this.was_Will_Der_Trottel_Malen = was_Will_Der_Trottel_Malen;
	}

	/**
	 * Sets the winkel.
	 * @param winkel The winkel to set
	 */
	public void setWinkel(JRadioButton winkel) {
		Winkel = winkel;
	}

	/**
	 * Sets the zeichenbrett.
	 * @param zeichenbrett The zeichenbrett to set
	 */
	public void setZeichenbrett(ZeichenbrettPanel zeichenbrett) {
		Zeichenbrett = zeichenbrett;
	}

	
	/**
	 * Returns the braucheFuellAttribute.
	 * @return boolean
	 */
	public boolean isBraucheFuellAttribute() {
		return braucheFuellAttribute;
	}

	/**
	 * Returns the braucheStrichAttribute.
	 * @return boolean
	 */
	public boolean isBraucheStrichAttribute() {
		return braucheStrichAttribute;
	}

	/**
	 * Returns the farbwahl.
	 * @return JPanel
	 */
	public JPanel getFarbwahl() {
		return Farbwahl;
	}

	/**
	 * Returns the fill.
	 * @return JButton
	 */
	public JButton getFill() {
		return Fill;
	}

	/**
	 * Returns the gradFarbe.
	 * @return JPanel
	 */
	public JPanel getGradFarbe() {
		return gradFarbe;
	}

	/**
	 * Returns the normFarbe.
	 * @return JPanel
	 */
	public JPanel getNormFarbe() {
		return normFarbe;
	}

	/**
	 * Returns the strichbreite.
	 * @return JPanel
	 */
	public JPanel getStrichbreite() {
		return Strichbreite;
	}

	/**
	 * Returns the stroke.
	 * @return JButton
	 */
	public JButton getStroke() {
		return Stroke;
	}

	/**
	 * Returns the textureFarbe.
	 * @return JPanel
	 */
	public JPanel getTextureFarbe() {
		return textureFarbe;
	}

	
	/**
	 * Sets the braucheFuellAttribute.
	 * @param braucheFuellAttribute The braucheFuellAttribute to set
	 */
	public void setBraucheFuellAttribute(boolean braucheFuellAttribute) {
		this.braucheFuellAttribute = braucheFuellAttribute;
	}

	/**
	 * Sets the braucheStrichAttribute.
	 * @param braucheStrichAttribute The braucheStrichAttribute to set
	 */
	public void setBraucheStrichAttribute(boolean braucheStrichAttribute) {
		this.braucheStrichAttribute = braucheStrichAttribute;
	}

	/**
	 * Sets the farbwahl.
	 * @param farbwahl The farbwahl to set
	 */
	public void setFarbwahl(JPanel farbwahl) {
		Farbwahl = farbwahl;
	}

	/**
	 * Sets the fill.
	 * @param fill The fill to set
	 */
	public void setFill(JButton fill) {
		Fill = fill;
	}

	/**
	 * Sets the gradFarbe.
	 * @param gradFarbe The gradFarbe to set
	 */
	public void setGradFarbe(JPanel gradFarbe) {
		this.gradFarbe = gradFarbe;
	}

	/**
	 * Sets the normFarbe.
	 * @param normFarbe The normFarbe to set
	 */
	public void setNormFarbe(JPanel normFarbe) {
		this.normFarbe = normFarbe;
	}

	/**
	 * Sets the strichbreite.
	 * @param strichbreite The strichbreite to set
	 */
	public void setStrichbreite(JPanel strichbreite) {
		Strichbreite = strichbreite;
	}

	/**
	 * Sets the stroke.
	 * @param stroke The stroke to set
	 */
	public void setStroke(JButton stroke) {
		Stroke = stroke;
	}

	/**
	 * Sets the textureFarbe.
	 * @param textureFarbe The textureFarbe to set
	 */
	public void setTextureFarbe(JPanel textureFarbe) {
		this.textureFarbe = textureFarbe;
	}

	/**
	 * Returns the blau.
	 * @return JRadioButton
	 */
	public JRadioButton getBlau() {
		return blau;
	}

	/**
	 * Returns the gelb.
	 * @return JRadioButton
	 */
	public JRadioButton getGelb() {
		return gelb;
	}

	/**
	 * Returns the grad_blau_rot.
	 * @return JRadioButton
	 */
	public JRadioButton getGrad_blau_rot() {
		return grad_blau_rot;
	}

	/**
	 * Returns the grad_gruen_gelb.
	 * @return JRadioButton
	 */
	public JRadioButton getgrad_gruen_gelb() {
		return grad_gruen_gelb;
	}

	/**
	 * Returns the grad_rot_schwarz.
	 * @return JRadioButton
	 */
	public JRadioButton getGrad_rot_schwarz() {
		return grad_rot_schwarz;
	}

	/**
	 * Returns the gruen.
	 * @return JRadioButton
	 */
	public JRadioButton getGruen() {
		return gruen;
	}

	/**
	 * Returns the orange.
	 * @return JRadioButton
	 */
	public JRadioButton getOrange() {
		return orange;
	}

	/**
	 * Returns the pink.
	 * @return JRadioButton
	 */
	public JRadioButton getPink() {
		return pink;
	}

	/**
	 * Returns the rot.
	 * @return JRadioButton
	 */
	public JRadioButton getRot() {
		return rot;
	}

	/**
	 * Returns the strichst_1.
	 * @return JRadioButton
	 */
	public JRadioButton getStrichst_1() {
		return strichst_1;
	}

	/**
	 * Returns the strichst_2.
	 * @return JRadioButton
	 */
	public JRadioButton getStrichst_2() {
		return strichst_2;
	}

	/**
	 * Returns the strichst_3.
	 * @return JRadioButton
	 */
	public JRadioButton getStrichst_3() {
		return strichst_3;
	}

	/**
	 * Returns the strokewahl.
	 * @return JPanel
	 */
	public JPanel getStrokewahl() {
		return Strokewahl;
	}

	/**
	 * Returns the texturepaint_1.
	 * @return JRadioButton
	 */
	public JRadioButton getTexturepaint_1() {
		return texturepaint_1;
	}

	/**
	 * Returns the wie_dick_mog_as_denn.
	 * @return ButtonGroup
	 */
	public ButtonGroup getWie_dick_mog_as_denn() {
		return wie_dick_mog_as_denn;
	}

	/**
	 * Sets the blau.
	 * @param blau The blau to set
	 */
	public void setBlau(JRadioButton blau) {
		this.blau = blau;
	}

	/**
	 * Sets the gelb.
	 * @param gelb The gelb to set
	 */
	public void setGelb(JRadioButton gelb) {
		this.gelb = gelb;
	}

	/**
	 * Sets the grad_blau_rot.
	 * @param grad_blau_rot The grad_blau_rot to set
	 */
	public void setGrad_blau_rot(JRadioButton grad_blau_rot) {
		this.grad_blau_rot = grad_blau_rot;
	}

	/**
	 * Sets the grad_gruen_gelb.
	 * @param grad_gruen_gelb The grad_gruen_gelb to set
	 */
	public void setgrad_gruen_gelb(JRadioButton grad_gruen_gelb) {
		this.grad_gruen_gelb = grad_gruen_gelb;
	}

	/**
	 * Sets the grad_rot_schwarz.
	 * @param grad_rot_schwarz The grad_rot_schwarz to set
	 */
	public void setGrad_rot_schwarz(JRadioButton grad_rot_schwarz) {
		this.grad_rot_schwarz = grad_rot_schwarz;
	}

	/**
	 * Sets the gruen.
	 * @param gruen The gruen to set
	 */
	public void setGruen(JRadioButton gruen) {
		this.gruen = gruen;
	}

	/**
	 * Sets the orange.
	 * @param orange The orange to set
	 */
	public void setOrange(JRadioButton orange) {
		this.orange = orange;
	}

	/**
	 * Sets the pink.
	 * @param pink The pink to set
	 */
	public void setPink(JRadioButton pink) {
		this.pink = pink;
	}

	/**
	 * Sets the rot.
	 * @param rot The rot to set
	 */
	public void setRot(JRadioButton rot) {
		this.rot = rot;
	}

	/**
	 * Sets the strichst_1.
	 * @param strichst_1 The strichst_1 to set
	 */
	public void setStrichst_1(JRadioButton strichst_1) {
		this.strichst_1 = strichst_1;
	}

	/**
	 * Sets the strichst_2.
	 * @param strichst_2 The strichst_2 to set
	 */
	public void setStrichst_2(JRadioButton strichst_2) {
		this.strichst_2 = strichst_2;
	}

	/**
	 * Sets the strichst_3.
	 * @param strichst_3 The strichst_3 to set
	 */
	public void setStrichst_3(JRadioButton strichst_3) {
		this.strichst_3 = strichst_3;
	}

	/**
	 * Sets the strokewahl.
	 * @param strokewahl The strokewahl to set
	 */
	public void setStrokewahl(JPanel strokewahl) {
		Strokewahl = strokewahl;
	}

	/**
	 * Sets the texturepaint_1.
	 * @param texturepaint_1 The texturepaint_1 to set
	 */
	public void setTexturepaint_1(JRadioButton texturepaint_1) {
		this.texturepaint_1 = texturepaint_1;
	}

	/**
	 * Sets the wie_dick_mog_as_denn.
	 * @param wie_dick_mog_as_denn The wie_dick_mog_as_denn to set
	 */
	public void setWie_dick_mog_as_denn(ButtonGroup wie_dick_mog_as_denn) {
		this.wie_dick_mog_as_denn = wie_dick_mog_as_denn;
	}

	/**
	 * Returns the welches_Schweinderl_haettens_denn_gerne.
	 * @return ButtonGroup
	 */
	public ButtonGroup getWelches_Schweinderl_haettens_denn_gerne() {
		return welches_Schweinderl_haettens_denn_gerne;
	}

	/**
	 * Sets the welches_Schweinderl_haettens_denn_gerne.
	 * @param welches_Schweinderl_haettens_denn_gerne The welches_Schweinderl_haettens_denn_gerne to set
	 */
	public void setWelches_Schweinderl_haettens_denn_gerne(ButtonGroup welches_Schweinderl_haettens_denn_gerne) {
		this.welches_Schweinderl_haettens_denn_gerne =
			welches_Schweinderl_haettens_denn_gerne;
	}

	/**
	 * Returns the renderingGschichten.
	 * @return JPanel
	 */
	public JPanel getRenderingGschichten() {
		return RenderingGschichten;
	}

	/**
	 * Returns the renderingTitel.
	 * @return JLabel
	 */
	public JLabel getRenderingTitel() {
		return RenderingTitel;
	}

	/**
	 * Sets the renderingGschichten.
	 * @param renderingGschichten The renderingGschichten to set
	 */
	public void setRenderingGschichten(JPanel renderingGschichten) {
		RenderingGschichten = renderingGschichten;
	}

	/**
	 * Sets the renderingTitel.
	 * @param renderingTitel The renderingTitel to set
	 */
	public void setRenderingTitel(JLabel renderingTitel) {
		RenderingTitel = renderingTitel;
	}

	/**
	 * Returns the aktuelleFarbe.
	 * @return Color
	 */
	public Color getAktuelleFarbe() {
		return aktuelleFarbe;
	}

	/**
	 * Returns the aktuellerStroke.
	 * @return Stroke
	 */
	public Stroke getAktuellerStroke() {
		return aktuellerStroke;
	}

	/**
	 * Returns the allg_Ren_Titel.
	 * @return JLabel
	 */
	public JLabel getAllg_Ren_Titel() {
		return Allg_Ren_Titel;
	}

	/**
	 * Returns the allgemeines_rendering.
	 * @return JPanel
	 */
	public JPanel getAllgemeines_rendering() {
		return allgemeines_rendering;
	}

	/**
	 * Returns the anfangspunkt_Linie.
	 * @return Point2D
	 */
	public Point2D getAnfangspunkt_Linie() {
		return Anfangspunkt_Linie;
	}

	/**
	 * Returns the anti_aliasing_panel.
	 * @return JPanel
	 */
	public JPanel getAnti_aliasing_panel() {
		return anti_aliasing_panel;
	}

	/**
	 * Returns the antialiasing_Off.
	 * @return JRadioButton
	 */
	public JRadioButton getAntialiasing_Off() {
		return antialiasing_Off;
	}

	/**
	 * Returns the antialiasing_On.
	 * @return JRadioButton
	 */
	public JRadioButton getAntialiasing_On() {
		return antialiasing_On;
	}

	/**
	 * Returns the antialiasing_Titel.
	 * @return JLabel
	 */
	public JLabel getAntialiasing_Titel() {
		return antialiasing_Titel;
	}

	/**
	 * Returns the b1.
	 * @return Stroke
	 */
	public Stroke getB1() {
		return b1;
	}

	/**
	 * Returns the b2.
	 * @return Stroke
	 */
	public Stroke getB2() {
		return b2;
	}

	/**
	 * Returns the b3.
	 * @return Stroke
	 */
	public Stroke getB3() {
		return b3;
	}

	/**
	 * Returns the bg_antialiasing.
	 * @return ButtonGroup
	 */
	public ButtonGroup getBg_antialiasing() {
		return bg_antialiasing;
	}

	/**
	 * Returns the bg_dithering.
	 * @return ButtonGroup
	 */
	public ButtonGroup getBg_dithering() {
		return bg_dithering;
	}

	/**
	 * Returns the bg_rendering.
	 * @return ButtonGroup
	 */
	public ButtonGroup getBg_rendering() {
		return bg_rendering;
	}

	/**
	 * Returns the dithering_Off.
	 * @return JRadioButton
	 */
	public JRadioButton getDithering_Off() {
		return dithering_Off;
	}

	/**
	 * Returns the dithering_On.
	 * @return JRadioButton
	 */
	public JRadioButton getDithering_On() {
		return dithering_On;
	}

	/**
	 * Returns the dithering_panel.
	 * @return JPanel
	 */
	public JPanel getDithering_panel() {
		return dithering_panel;
	}

	/**
	 * Returns the dithering_Titel.
	 * @return JLabel
	 */
	public JLabel getDithering_Titel() {
		return Dithering_Titel;
	}

	
	/**
	 * Returns the endPunkt_Linie.
	 * @return Point2D
	 */
	public Point2D getEndPunkt_Linie() {
		return EndPunkt_Linie;
	}

	/**
	 * Returns the gP_Vector.
	 * @return Vector
	 */
	public Vector getGP_Vector() {
		return GP_Vector;
	}

	/**
	 * Returns the grad_gruen_gelb.
	 * @return JRadioButton
	 */
	public JRadioButton getGrad_gruen_gelb() {
		return grad_gruen_gelb;
	}

	/**
	 * Returns the grd_Color.
	 * @return int
	 */
	public int getGrd_Color() {
		return Grd_Color;
	}

	/**
	 * Returns the liniezeichnen.
	 * @return boolean
	 */
	public boolean isLiniezeichnen() {
		return liniezeichnen;
	}

	/**
	 * Returns the rendering_Quality.
	 * @return JRadioButton
	 */
	public JRadioButton getRendering_Quality() {
		return rendering_Quality;
	}

	/**
	 * Returns the rendering_Schnell.
	 * @return JRadioButton
	 */
	public JRadioButton getRendering_Schnell() {
		return rendering_Schnell;
	}

	/**
	 * Returns the textureColor.
	 * @return int
	 */
	public int getTextureColor() {
		return textureColor;
	}

	/**
	 * Sets the aktuelleFarbe.
	 * @param aktuelleFarbe The aktuelleFarbe to set
	 */
	public void setAktuelleFarbe(Color aktuelleFarbe) {
		this.aktuelleFarbe = aktuelleFarbe;
	}

	/**
	 * Sets the aktuellerStroke.
	 * @param aktuellerStroke The aktuellerStroke to set
	 */
	public void setAktuellerStroke(Stroke aktuellerStroke) {
		this.aktuellerStroke = aktuellerStroke;
	}

	/**
	 * Sets the allg_Ren_Titel.
	 * @param allg_Ren_Titel The allg_Ren_Titel to set
	 */
	public void setAllg_Ren_Titel(JLabel allg_Ren_Titel) {
		Allg_Ren_Titel = allg_Ren_Titel;
	}

	/**
	 * Sets the allgemeines_rendering.
	 * @param allgemeines_rendering The allgemeines_rendering to set
	 */
	public void setAllgemeines_rendering(JPanel allgemeines_rendering) {
		this.allgemeines_rendering = allgemeines_rendering;
	}

	/**
	 * Sets the anfangspunkt_Linie.
	 * @param anfangspunkt_Linie The anfangspunkt_Linie to set
	 */
	public void setAnfangspunkt_Linie(Point2D anfangspunkt_Linie) {
		Anfangspunkt_Linie = anfangspunkt_Linie;
	}

	/**
	 * Sets the anti_aliasing_panel.
	 * @param anti_aliasing_panel The anti_aliasing_panel to set
	 */
	public void setAnti_aliasing_panel(JPanel anti_aliasing_panel) {
		this.anti_aliasing_panel = anti_aliasing_panel;
	}

	/**
	 * Sets the antialiasing_Off.
	 * @param antialiasing_Off The antialiasing_Off to set
	 */
	public void setAntialiasing_Off(JRadioButton antialiasing_Off) {
		this.antialiasing_Off = antialiasing_Off;
	}

	/**
	 * Sets the antialiasing_On.
	 * @param antialiasing_On The antialiasing_On to set
	 */
	public void setAntialiasing_On(JRadioButton antialiasing_On) {
		this.antialiasing_On = antialiasing_On;
	}

	/**
	 * Sets the antialiasing_Titel.
	 * @param antialiasing_Titel The antialiasing_Titel to set
	 */
	public void setAntialiasing_Titel(JLabel antialiasing_Titel) {
		this.antialiasing_Titel = antialiasing_Titel;
	}

	/**
	 * Sets the b1.
	 * @param b1 The b1 to set
	 */
	public void setB1(Stroke b1) {
		this.b1 = b1;
	}

	/**
	 * Sets the b2.
	 * @param b2 The b2 to set
	 */
	public void setB2(Stroke b2) {
		this.b2 = b2;
	}

	/**
	 * Sets the b3.
	 * @param b3 The b3 to set
	 */
	public void setB3(Stroke b3) {
		this.b3 = b3;
	}

	/**
	 * Sets the bg_antialiasing.
	 * @param bg_antialiasing The bg_antialiasing to set
	 */
	public void setBg_antialiasing(ButtonGroup bg_antialiasing) {
		this.bg_antialiasing = bg_antialiasing;
	}

	/**
	 * Sets the bg_dithering.
	 * @param bg_dithering The bg_dithering to set
	 */
	public void setBg_dithering(ButtonGroup bg_dithering) {
		this.bg_dithering = bg_dithering;
	}

	/**
	 * Sets the bg_rendering.
	 * @param bg_rendering The bg_rendering to set
	 */
	public void setBg_rendering(ButtonGroup bg_rendering) {
		this.bg_rendering = bg_rendering;
	}

	/**
	 * Sets the dithering_Off.
	 * @param dithering_Off The dithering_Off to set
	 */
	public void setDithering_Off(JRadioButton dithering_Off) {
		this.dithering_Off = dithering_Off;
	}

	/**
	 * Sets the dithering_On.
	 * @param dithering_On The dithering_On to set
	 */
	public void setDithering_On(JRadioButton dithering_On) {
		this.dithering_On = dithering_On;
	}

	/**
	 * Sets the dithering_panel.
	 * @param dithering_panel The dithering_panel to set
	 */
	public void setDithering_panel(JPanel dithering_panel) {
		this.dithering_panel = dithering_panel;
	}

	/**
	 * Sets the dithering_Titel.
	 * @param dithering_Titel The dithering_Titel to set
	 */
	public void setDithering_Titel(JLabel dithering_Titel) {
		Dithering_Titel = dithering_Titel;
	}

	

	/**
	 * Sets the endPunkt_Linie.
	 * @param endPunkt_Linie The endPunkt_Linie to set
	 */
	public void setEndPunkt_Linie(Point2D endPunkt_Linie) {
		EndPunkt_Linie = endPunkt_Linie;
	}

	/**
	 * Sets the gP_Vector.
	 * @param gP_Vector The gP_Vector to set
	 */
	public void setGP_Vector(Vector gP_Vector) {
		GP_Vector = gP_Vector;
	}

	/**
	 * Sets the grad_gruen_gelb.
	 * @param grad_gruen_gelb The grad_gruen_gelb to set
	 */
	public void setGrad_gruen_gelb(JRadioButton grad_gruen_gelb) {
		this.grad_gruen_gelb = grad_gruen_gelb;
	}

	/**
	 * Sets the grd_Color.
	 * @param grd_Color The grd_Color to set
	 */
	public void setGrd_Color(int grd_Color) {
		Grd_Color = grd_Color;
	}

	/**
	 * Sets the liniezeichnen.
	 * @param liniezeichnen The liniezeichnen to set
	 */
	public void setLiniezeichnen(boolean liniezeichnen) {
		this.liniezeichnen = liniezeichnen;
	}

	/**
	 * Sets the rendering_Quality.
	 * @param rendering_Quality The rendering_Quality to set
	 */
	public void setRendering_Quality(JRadioButton rendering_Quality) {
		this.rendering_Quality = rendering_Quality;
	}

	/**
	 * Sets the rendering_Schnell.
	 * @param rendering_Schnell The rendering_Schnell to set
	 */
	public void setRendering_Schnell(JRadioButton rendering_Schnell) {
		this.rendering_Schnell = rendering_Schnell;
	}

	/**
	 * Sets the textureColor.
	 * @param textureColor The textureColor to set
	 */
	public void setTextureColor(int textureColor) {
		this.textureColor = textureColor;
	}

	/**
	 * Returns the basisAuswahl.
	 * @return JPanel
	 */
	public JPanel getBasisAuswahl() {
		return basisAuswahl;
	}

	/**
	 * Returns the manipulationsPanel.
	 * @return JPanel
	 */
	public JPanel getManipulationsPanel() {
		return manipulationsPanel;
	}

	/**
	 * Returns the editModus.
	 * @return JRadioButton
	 */
	public JRadioButton getEditModus() {
		return editModus;
	}

	/**
	 * Returns the malModus.
	 * @return JRadioButton
	 */
	public JRadioButton getMalModus() {
		return malModus;
	}

	/**
	 * Returns the neuesBlatt.
	 * @return JButton
	 */
	public JButton getNeuesBlatt() {
		return neuesBlatt;
	}

	/**
	 * Returns the rotate_left.
	 * @return JButton
	 */
	public JButton getRotate_left() {
		return rotate_left;
	}

	/**
	 * Returns the rotate_right.
	 * @return JButton
	 */
	public JButton getRotate_right() {
		return rotate_right;
	}

	/**
	 * Returns the zoom_in.
	 * @return JButton
	 */
	public JButton getZoom_in() {
		return zoom_in;
	}

	/**
	 * Returns the zoom_out.
	 * @return JButton
	 */
	public JButton getZoom_out() {
		return zoom_out;
	}



}
