import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;
/**
 * @author MR_J
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class ZeichenbrettPanel extends JPanel
{
	private Vector Shape_Vektor;
	
	private GradientPaint rotschwarz,gruenblau,blaurot;
	
	private TexturePaint t1;
	
	AffineTransform save;	
	
	final static float dash1[] = {10.0f};
    
    final static BasicStroke dashed = new BasicStroke(5.0f, 
                                                      BasicStroke.CAP_BUTT, 
                                                      BasicStroke.JOIN_MITER, 
                                                      10.0f, dash1, 0.0f);
	public ZeichenbrettPanel()
	{
	Shape_Vektor = new Vector();
	
	}

	/**
	 * Returns the shape_Vektor.
	 * @return Vector
	 */
	public Vector getShape_Vektor() {
		return Shape_Vektor;
	}

	/**
	 * Sets the shape_Vektor.
	 * @param shape_Vektor The shape_Vektor to set
	 */
	public void setShape_Vektor(Vector shape_Vektor) {
		Shape_Vektor = shape_Vektor;
	}

	public void paintComponent(Graphics g)
	{
	if(Shape_Vektor.size()!=0)
	{
			
			Graphics2D g2 = (Graphics2D) g;
			System.out.println("Bin in paint angekommen...");
			g2.clearRect(0,0,this.getWidth(),this.getHeight());
			save = g2.getTransform();
				
				for(int i = 0;i<Shape_Vektor.size();i++)
				{
					
					if(!(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape() instanceof Line2D))
					{
						System.out.println(""+i +" Geom...\n");
					
						if(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getDithering()==0)
							g2.setRenderingHint(RenderingHints.KEY_DITHERING,RenderingHints.VALUE_DITHER_DISABLE);
						else
							g2.setRenderingHint(RenderingHints.KEY_DITHERING,RenderingHints.VALUE_DITHER_ENABLE);
						
						if(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getAntiAliasing()==1)
							g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
						else
							g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_OFF);
						
						if(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getRender_Allgemein()==0)
							g2.setRenderingHint(RenderingHints.KEY_RENDERING,RenderingHints.VALUE_RENDER_SPEED);
						else
							g2.setRenderingHint(RenderingHints.KEY_RENDERING,RenderingHints.VALUE_RENDER_QUALITY);
						
						AffineTransform aTemp = new AffineTransform();

						
						aTemp.concatenate((AffineTransform)((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMy_Rotate_AT());
						aTemp.concatenate((AffineTransform)((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMy_Translate_AT());
						aTemp.concatenate((AffineTransform)((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMy_Scale_AT());
						//aTemp.concatenate(g2.getTransform());
						
						g2.transform(aTemp);
														
						if(!((Zeichen_Object)(Shape_Vektor.elementAt(i))).isIstSelektiert())	
						{	
							
							g2.setStroke(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyStroke());
							g2.draw(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape());
							
						}
						else
						{
							
								g2.setClip(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape().getBounds2D());
								g2.setPaint(Color.MAGENTA);
								g2.setStroke(dashed);
								g2.draw(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape());
							
								g2.setColor(Color.WHITE);
								g2.draw(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape().getBounds2D());
								
								g2.setPaint(Color.BLACK);
								g2.setStroke(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyStroke());
								
						}
							
						if(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyNormalColor()!=null)
						{
							g2.setPaint(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyNormalColor());
							g2.fill(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape());
							g2.setPaint(Color.BLACK);
							g2.setTransform(save);
						}
					
						if(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyGradientPaint()==1)
						{
							rotschwarz= new GradientPaint(
								(int)((((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape()).getBounds()).getX(),
								(int)((((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape()).getBounds()).getY(),
								Color.BLACK,
								(int)((((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape()).getBounds()).getX()+
								(int)((((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape()).getBounds()).getWidth(),
								(int)((((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape()).getBounds()).getY()+
								(int)((((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape()).getBounds()).getHeight()
								,Color.RED);
							g2.setPaint(rotschwarz);
							g2.fill(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape());
							g2.setPaint(Color.BLACK);
							
						}
					
						if(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyGradientPaint()==2)
						{
							gruenblau= new GradientPaint(
								(int)((((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape()).getBounds()).getX(),
								(int)((((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape()).getBounds()).getY(),
								Color.GREEN,
								(int)((((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape()).getBounds()).getX()+
								(int)((((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape()).getBounds()).getWidth(),
								(int)((((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape()).getBounds()).getY()+
								(int)((((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape()).getBounds()).getHeight()
								,Color.YELLOW);
							g2.setPaint(gruenblau);
							g2.fill(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape());
							g2.setPaint(Color.BLACK);
							
						}
					
						if(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyGradientPaint()==3)
						{
							blaurot= new GradientPaint(
								(int)((((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape()).getBounds()).getX(),
								(int)((((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape()).getBounds()).getY(),
								Color.BLUE,
								(int)((((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape()).getBounds()).getX()+
								(int)((((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape()).getBounds()).getWidth(),
								(int)((((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape()).getBounds()).getY()+
								(int)((((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape()).getBounds()).getHeight()
								,Color.RED);
							g2.setPaint(blaurot);
							g2.fill(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape());
							g2.setPaint(Color.BLACK);
							
						}
						
						if(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyTexturePaint()==1)
						{
							BufferedImage bi = new BufferedImage(20, 20, BufferedImage.TYPE_INT_RGB);
		    				Graphics2D big = bi.createGraphics();
							big.setColor(Color.BLACK);
							big.fillRect(0, 0, 20, 20);
							big.setColor(Color.BLUE);
							big.fillOval(0, 0, 15, 15);
							Rectangle r = new Rectangle(0,0,20,20);
							g2.setPaint(new TexturePaint(bi, r));
							g2.fill(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape());
							g2.setPaint(Color.BLACK);
							
						}
						g2.setTransform(save);
					}
				else //Shape is ne Linie, dann Wird nur gezeichnet und nicht aufgefllt.
					{
					System.out.println(""+i +" Geom...\n");
					g2.setStroke(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyStroke());
					g2.draw(((Zeichen_Object)(Shape_Vektor.elementAt(i))).getMyShape());
					}	
				
				}
				
				
				
		}
	
	}
}
